﻿# -*- coding: utf-8 -*-
import urllib, urlparse
import re, json, base64
from HTMLParser import HTMLParser

def httpget(url):
	try:
		file = urllib.urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urllib.urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

def show_page(url):
	id = re.search('http://www.youku.com/show_page/id_(.*?)\.html', url)
	if id == None:
		return {'success': False, 'code':'youku 200'}
	id = id.group(1)
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 201'}
	result = {'success': True, 'item': []}
	m = re.findall('<a [^<>]*y.episode.show\(\'(.*?)\'\)[^<>]*>(.*?)</a>', content)
	if m:
		for e in m:
			url = 'http://www.youku.com/show_episode/id_' + id + '.html?divid=' + e[0]
			result['item'].append({'title':e[1], 'url':url})
	else:
		s = re.search('<div id="episode">(.*?)</div>', content, re.DOTALL)
		if s:
			s = s.group(1)
			m = re.findall('<ul.*?>(.*?)</ul>', s, re.DOTALL)
			for e in m:
				s = re.search('<a [^<>]*href="(.*?)"[^<>]*title="(.*?)"[^<>]*>', e)
				if s == None:
					continue
				result['item'].append({'title':s.group(2), 'url':s.group(1)})
	return result

def show_episode(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 300'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul.*?>(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*>(.*?)</a>', e)
		if s == None:
			continue
		result['item'].append({'title':s.group(2), 'url':s.group(1)})
	return result

def playlist(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 400'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul class="v">(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*title="(.*?)"[^<>]*href="(.*?)"[^<>]*>', e)
		if s == None:
			continue
		title = HTMLParser().unescape(s.group(1).decode('utf-8')).encode('utf-8')
		result['item'].append({'title':title, 'url':s.group(2)})
	s = re.search('<div class="page f_r">(.*?)</div>', content, re.DOTALL)
	if s:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*title=\'下一页\'[^<>]*>', s.group(1))
		if s:
			result['item'].append({'title':'Load more', 'url':s.group(1)})
	return result

def play(url):
	# https://github.com/yudun1989/youku-m3u8/blob/master/youku-python-parser.py
	# http://www.cnblogs.com/keygle/p/3829653.html
	def my_encoder(a, s):
		result = ''
		b = []
		for i in range(256):
			b.append(i)
		f = 0
		for h in range(256):
			f = (f + b[h] + ord(a[h % len(a)])) % 256
			temp = b[h]
			b[h] = b[f]
			b[f] = temp
		f = 0
		h = 0
		for c in s:
			h = (h + 1) % 256
			f = (f + b[h]) % 256
			temp = b[h]
			b[h] = b[f]
			b[f] = temp
			x = ord(c) ^ b[(b[h] + b[f]) % 256]
			result += chr(x)
		return result
		
	def getid(fileid, seed):
		source = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/\\:._-1234567890'
		mixed = ''
		while source:
			seed = (seed * 211 + 30031) % 65536
			index = seed * len(source) / 65536
			mixed += source[index]
			source = source[:index] + source[index + 1:]
		realId = ''
		for index in fileid.rstrip('*').split('*'):
			realId += mixed[int(index)]
		return realId

	vid = re.search('http://v.youku.com/v_show/id_(.*?)\.html', url)
	if vid == None:
		return {'success': False, 'code':'youku 100'}
	vid = vid.group(1)
	url = 'http://v.youku.com/player/getPlayList/VideoIDS/' + vid + '/Pf/4/ctype/12/ev/1'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 101'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youku 102'}
	title = data['data'][0]['title']
	video_ip = data['data'][0]['ip']
	video_ep = data['data'][0]['ep']
	seed = data['data'][0]['seed']
	segs = data['data'][0]['segs']
	streamfileids = data['data'][0]['streamfileids']
	template1 = 'becaf9be';
	template2 = 'bf7e5f01';
	decoded = base64.b64decode(video_ep)
	temp = my_encoder(template1, decoded)
	temp_splited = temp.split('_')
	sid = temp_splited[0]
	token = temp_splited[1]
	filetypes = {'flv' : 'flv', 'mp4' : 'mp4', 'hd2' : 'flv', '3gphd' : 'mp4', '3gp' : 'flv', 'hd3' : 'flv'}
	result = {'success': True, 'title': title, 'url': {}}
	for seg in segs:
		result['url'][seg] = []
		fileid = getid(streamfileids[seg], seed)
		for part in segs[seg]:
			fileid = fileid[:8] + '%02X' % int(part['no']) + fileid[10:]
			whole = sid + '_' + fileid + '_' + token
			ep_new = my_encoder(template2, whole)
			ep_new = base64.b64encode(ep_new)
			ep_new = urllib.quote(ep_new)
			filetype = filetypes[seg]
			url = 'http://k.youku.com/player/getFlvPath/sid/' + sid + '_00/st/' + filetype + '/fileid/' + fileid + '?K=' + part['k'] + '&hd=1&myp=0&ts=' + str(part['seconds']) + '&ypp=0&ctype=12&ev=1&token=' + token + '&oip=' + str(video_ip) + '&ep=' + ep_new
			result['url'][seg].append(url)
	whole = sid + '_' + vid + '_' + token
	ep_new = my_encoder(template2, whole)
	ep_new = base64.b64encode(ep_new)
	ep_new = urllib.quote(ep_new)
	url = 'http://pl.youku.com/playlist/m3u8?ctype=12&ep=' + ep_new + '&ev=1&keyframe=1&oip=' + str(video_ip) + '&sid=' + sid + '&token=' + token + '&type=' + 'mp4' + '&vid=' + vid
	result['url']['mp4m3u8'] = [url]
	url = 'http://pl.youku.com/playlist/m3u8?ctype=12&ep=' + ep_new + '&ev=1&keyframe=1&oip=' + str(video_ip) + '&sid=' + sid + '&token=' + token + '&type=' + 'flv' + '&vid=' + vid
	result['url']['flvm3u8'] = [url]
	return result
